<div th:replace="@{Lensa/Layout/Top}"></div>

<script>
  const formatRupiah = (money) => {
    return new Intl.NumberFormat("id-ID", {
      style: "currency",
      currency: "IDR",
      minimumFractionDigits: 0,
    }).format(money);
  };
</script>

<body id="page-top">
  <!-- Page Wrapper -->
  <div id="wrapper">
    <div th:replace="@{Lensa/Layout/Sidebar}"></div>

    <!-- Content Wrapper -->
    <div id="content-wrapper" class="d-flex flex-column">
      <!-- Main Content -->
      <div id="content">
        <div th:replace="@{Lensa/Layout/Topbar}"></div>

        <!-- Begin Page Content -->
        <div class="container-fluid">
          <!-- Page Heading -->
          <h1 class="h3 mb-2 text-gray-800">Data Pembelian</h1>

          <div th:replace="@{Lensa/Layout/ErrorAllert}"></div>

          <!-- TOMBOL -->

          <script>
            $(document).ready(function () {
              // Append table with add row form on add new button click
              $(document).on("click", "#btnSearch", function () {
                holder = $("#inputSearch").val();
                window.location.href = "/pembelian/" + holder;
              });
            });
          </script>

          <div class="text-start w-50">
            <div class="row">
              <div class="col">
                <div class="input-group mb-3">
                  <input
                    type="text"
                    class="form-control"
                    placeholder="Nama Pembeli.."
                    aria-label="Nama Pembeli.."
                    aria-describedby="button-addon2"
                    id="inputSearch"
                    list="namaPembeli"
                    th:value="${Search != null ? Search : ''}"
                  />
                  <datalist id="namaPembeli">
                    <option
                      th:each="pembeli : ${DataPembelian}"
                      th:value="${pembeli.Pembeli}"
                    ></option>
                  </datalist>

                  <button
                    class="btn btn-outline-secondary"
                    type="button"
                    id="btnSearch"
                  >
                    <i class="fa-solid fa-magnifying-glass"></i>
                  </button>
                </div>
              </div>
            </div>
          </div>

          <!-- TOMBOL TAMBAH DATA -->
          <!-- Button trigger modal -->
          <button
            type="button"
            class="btn btn-primary"
            data-bs-toggle="modal"
            data-bs-target="#exampleModal"
          >
            Tambah Data Pembelian
          </button>

          <!-- Modal -->
          <div
            class="modal fade"
            id="exampleModal"
            tabindex="-1"
            aria-labelledby="exampleModalLabel"
            aria-hidden="true"
          >
            <div class="modal-dialog">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title" id="exampleModalLabel">
                    Masukkan Data
                  </h5>
                  <button
                    type="button"
                    class="btn-close"
                    data-bs-dismiss="modal"
                    aria-label="Close"
                  ></button>
                </div>
                <div class="modal-body">
                  <!-- FORM TAMBAH DATA -->
                  <form
                    th:action="@{/pembelian/add}"
                    method="post"
                    id="addPembelian"
                  >
                    <div class="form-row">
                      <div class="form-group col-md-4">
                        <label for="KategoriPembeli" class="form-label"
                          >Yth.</label
                        >
                        <select
                          class="form-select"
                          name="KategoriPembeli"
                          id="KategoriPembeli"
                          required
                        >
                          <option value="Tuan" selected>Tuan</option>
                          <option value="Nyonya">Nyonya</option>
                          <option value="Nona">Nona</option>
                        </select>
                      </div>
                      <div class="form-group">
                        <label for="NamaPembeli" class="form-label"
                          >Nama Pembeli</label
                        >
                        <input
                          type="text"
                          class="form-control"
                          id="NamaPembeli"
                          name="Pembeli"
                          required
                        />
                      </div>
                    </div>
                    <div class="mb-3">
                      <label for="Pemeriksa" class="form-label"
                        >Pemeriksa</label
                      >
                      <input
                        type="text"
                        class="form-control"
                        id="Pemeriksa"
                        name="DrPemeriksa"
                        required
                      />
                    </div>
                    <div class="mb-3">
                      <label for="Lensa" class="form-label">Lensa</label>
                      <input
                        type="hidden"
                        hidden
                        id="HiddenLensa"
                        name="idLensa"
                      />
                      <input
                        type="text"
                        class="form-control"
                        id="Lensa"
                        list="daftaridLensa"
                        required
                      />
                      <p style="color: red" id="pivotHargaLensa">
                        Harga : Rp.0
                      </p>
                      <datalist id="daftaridLensa">
                        <option
                          th:each="lensa : ${DataLensa}"
                          th:value="${lensa.NamaLensa} + ' | '+ ${lensa.JenisLensa} + ' | ['+ ${lensa.UkuranKiri} + ', '+ ${lensa.UkuranKanan} +']'"
                          th:if="${lensa.StokLensa != 0}"
                        ></option>
                      </datalist>
                    </div>
                    <div class="mb-3">
                      <label for="Frame" class="form-label">Frame</label>
                      <input
                        type="hidden"
                        hidden
                        id="HiddenFrame"
                        name="idFrame"
                      />
                      <input
                        type="text"
                        class="form-control"
                        id="Frame"
                        list="daftaridFrame"
                        required
                      />
                      <p style="color: red" id="pivotHargaFrame">
                        Harga : Rp.0
                      </p>
                      <datalist id="daftaridFrame">
                        <option
                          th:each="Frame : ${DataFrame}"
                          th:value="${Frame.NamaFrame} + ' | '+ ${Frame.JenisFrame}"
                          th:if="${Frame.StokFrame != 0}"
                        ></option>
                      </datalist>
                    </div>
                    <div class="mb-3">
                      <label for="Box" class="form-label">Box</label>
                      <input type="hidden" hidden id="HiddenBox" name="idBox" />
                      <input
                        type="text"
                        class="form-control"
                        id="Box"
                        list="daftaridBox"
                        required
                      />
                      <p style="color: red" id="pivotHargaBox">Harga : Rp.0</p>
                      <datalist id="daftaridBox">
                        <option
                          th:each="Box : ${DataBox}"
                          th:value="${Box.NamaBox} + ' | '+ ${Box.JenisBox}"
                          th:if="${Box.StokBox != 0}"
                        ></option>
                      </datalist>
                    </div>
                    <div class="mb-3 input-group.date">
                      <label for="TanggalSelesai" class="form-label"
                        >Tanggal Selesai</label
                      >

                      <input
                        type="Date"
                        class="form-control addLensaDate"
                        id="TanggalSelesai"
                        name="TanggalSelesai"
                      />
                    </div>
                    <div class="mb-3">
                      <label for="UangMuka" class="form-label">Uang Muka</label>
                      <p style="color: red" id="pivotHargaTotal">
                        Harga total : Rp.0
                      </p>
                      <input
                        type="number"
                        class="form-control"
                        id="UangMuka"
                        name="UangMuka"
                        required
                      />
                      <p style="color: red" hidden id="pivotKembalian">
                        Kembalian : Rp.0
                      </p>
                    </div>
                  </form>

                  <script th:inline="javascript">
                    window.onload = function(){
                                        document
                                        .getElementById("Frame")
                                        .addEventListener(
                                            "change",
                                            FrameFunction
                                        );

                                        document
                                        .getElementById("Lensa")
                                        .addEventListener(
                                            "change",
                                            LensaFunction
                                        );

                                        document
                                        .getElementById("Box")
                                        .addEventListener(
                                            "change",
                                            BoxFunction
                                        );

                                    /*<![CDATA[*/
                                    function FrameFunction() {
                                        /*[# th:each="Frame : ${DataFrame}"]*/
                                        if ($("#Frame").val() == /*[[${Frame.NamaFrame} + ' | '+ ${Frame.JenisFrame}]]*/ ) {
                                            $("#pivotHargaFrame").text("Harga : " + formatRupiah(/*[[${Frame.Harga}]]*/));
                                            $("#HiddenFrame").val(/*[[${Frame.Id}]]*/)
                                        }
                                        /*[/]*/
                                        CheckTotal();
                                    }

                                    function LensaFunction() {
                                        /*[# th:each="Lensa : ${DataLensa}"]*/
                                        if ($("#Lensa").val() == /*[[${Lensa.NamaLensa} + ' | '+ ${Lensa.JenisLensa} + ' | ['+ ${Lensa.UkuranKiri} + ', '+ ${Lensa.UkuranKanan} +']']]*/ ) {
                                            $("#pivotHargaLensa").text("Harga : " + formatRupiah(/*[[${Lensa.Harga}]]*/));
                                            $("#HiddenLensa").val(/*[[${Lensa.Id}]]*/)
                                        }
                                        /*[/]*/
                                        CheckTotal();
                                    }

                                    function BoxFunction() {
                                        /*[# th:each="Box : ${DataBox}"]*/
                                        if ($("#Box").val() == /*[[${Box.NamaBox} + ' | '+ ${Box.JenisBox}]]*/ ) {
                                            $("#pivotHargaBox").text("Harga : " + formatRupiah(/*[[${Box.Harga}]]*/));
                                            $("#HiddenBox").val(/*[[${Box.Id}]]*/)
                                        }
                                        /*[/]*/
                                        CheckTotal();
                                    }

                                    function CheckTotal(){
                                      if ($("#Frame").val() != "" || $("#Lensa").val() != "" || $("#Box").val() != ""){
                                        Frame = parseInt($("#pivotHargaFrame").text().replace(/\D/g, ""));
                                        Lensa = parseInt($("#pivotHargaLensa").text().replace(/\D/g, ""));
                                        Box = parseInt($("#pivotHargaBox").text().replace(/\D/g, ""));
                                        $("#UangMuka").attr("min", Frame+Lensa+Box);
                                        $("#pivotHargaTotal").text("Harga total : "+formatRupiah(Frame+Lensa+Box));
                                      }
                                    }


                                    const source = document.getElementById('UangMuka');

                                    const UangMukaTracker = function(e) {
                                      Frame = parseInt($("#pivotHargaFrame").text().replace(/\D/g, ""));
                                      Lensa = parseInt($("#pivotHargaLensa").text().replace(/\D/g, ""));
                                      Box = parseInt($("#pivotHargaBox").text().replace(/\D/g, ""));

                                      Input = parseInt($("#UangMuka").val());

                                      total = Frame + Lensa + Box;

                                      if(Input >= total){
                                        $("#pivotKembalian").attr("hidden", false);
                                        $("#pembelianSubmit").attr("disabled", false);
                                        $("#pivotKembalian").text("Kembalian : " + formatRupiah(Input - total));
                                      }else{
                                        $("#pivotKembalian").attr("hidden", true);
                                        $("#pembelianSubmit").attr("disabled", true);
                                      }
                                    }

                                    source.addEventListener('input', UangMukaTracker);
                                    source.addEventListener('propertychange', UangMukaTracker); // for IE8
                                    // Firefox/Edge18-/IE9+ don’t fire on <select><option>
                                    // source.addEventListener('change', inputHandler);




                                    function UpdateHelper(idString) {
                                      /*[# th:each="Frame : ${DataFrame}"]*/
                                      if ($("#tempidFrame" + idString).val() == /*[[${Frame.NamaFrame} + ' | '+ ${Frame.JenisFrame}]]*/ ) {
                                          $("#updateFrame"+ idString).val( /*[[${Frame.Id}]]*/ )
                                      }
                                      /*[/]*/


                                      /*[# th:each="Lensa : ${DataLensa}"]*/
                                      if ($("#tempidLensa" + idString).val() == /*[[${Lensa.NamaLensa} + ' | '+ ${Lensa.JenisLensa} + ' | ['+ ${Lensa.UkuranKiri} + ', '+ ${Lensa.UkuranKanan} +']']]*/ ) {
                                          $("#updateLensa"+ idString).val( /*[[${Lensa.Id}]]*/ )
                                      }
                                      /*[/]*/

                                      /*[# th:each="Box : ${DataBox}"]*/
                                      if ($("#tempidBox" + idString).val() == /*[[${Box.NamaBox} + ' | '+ ${Box.JenisBox}]]*/ ) {
                                          $("#updateBox"+ idString).val( /*[[${Box.Id}]]*/ )
                                      }
                                      /*[/]*/
                                      document.getElementById(idString).submit();
                                    }

                                      /*[# th:each="pembelian : ${DataPembelian}"]*/
                                    document.getElementById(/*[['btnUpdate'+${pembelian.Id}]]*/).onclick = function(){UpdateHelper(/*[[${pembelian.Id}]]*/)};
                                      /*[/]*/


                                    /*]]>*/
                                  };
                  </script>

                  <!-- FORM TAMBAH DATA -->
                </div>
                <div class="modal-footer">
                  <button
                    type="button"
                    class="btn btn-secondary"
                    data-bs-dismiss="modal"
                  >
                    Batal
                  </button>

                  <button
                    type="submit"
                    class="btn btn-primary DateHelper"
                    form="addPembelian"
                    disabled
                    id="pembelianSubmit"
                  >
                    Submit
                  </button>
                </div>
              </div>
            </div>
          </div>

          <script>
            $(document).ready(function () {
              $('[data-toggle="tooltip"]').tooltip();
              var actions = $("table td:last-child").html();
              // Append table with add row form on add new button click
              $(document).on("click", ".DateHelper", function () {
                $(".addLensaDate").attr("type", "text");
              });
            });
          </script>

          <div class="table-title mt-3">
            <div class="row">
              <div class="col-sm-6">
                <h2>Daftar <b>Pembelian</b></h2>
              </div>
              <div class="col-sm-6">
                <div class="btn-group" data-toggle="buttons">
                  <label class="btn btn-info active">
                    <input
                      type="radio"
                      name="status"
                      value="all"
                      checked="checked"
                    />
                    All
                  </label>
                  <label class="btn btn-success">
                    <input type="radio" name="status" value="active" />
                    Selesai
                  </label>
                  <label class="btn btn-warning">
                    <input type="radio" name="status" value="inactive" />
                    Belum Selesai
                  </label>
                </div>
              </div>
            </div>
          </div>

          <div class="">
            <div class="table-responsive">
              <div
                class="table-wrapper mt-0"
                style="max-height: 500px; overflow: auto; display: inline-block"
              >
                <script>
                  $(document).ready(function () {
                    $('[data-toggle="tooltip"]').tooltip();
                    var actions = $("table td:last-child").html();
                    // Append table with add row form on add new button click
                    $(document).on("click", ".edit", function () {
                      holder = " ";
                      $(this)
                        .parents("tr")
                        .find("td:not(:last-child)")
                        .each(function () {
                          if ($(this).attr("id") == "Id") {
                            holder = $(this).text();
                            $(this).html(
                              '<input type="hidden" class="form-control" value="' +
                                $(this).text() +
                                '" id="' +
                                $(this).attr("id") +
                                '" name="' +
                                $(this).attr("id") +
                                '" form="' +
                                holder +
                                '" readonly>'
                            );
                          } else if ($(this).attr("id") == "Pembeli") {
                            $(this).html(
                              '<select class="form-select" required name="KategoriPembeli" id="KategoriPembeli" form="' +
                                holder +
                                '">' +
                                "<option " +
                                ($(this).text().split(" ")[0] == "Tuan"
                                  ? "selected "
                                  : "") +
                                ' value="Tuan">Tuan</option>' +
                                "<option " +
                                ($(this).text().split(" ")[0] == "Nyonya"
                                  ? "selected "
                                  : "") +
                                'value="Nyonya">Nyonya</option>' +
                                "<option " +
                                ($(this).text().split(" ")[0] == "Nona"
                                  ? "selected "
                                  : "") +
                                ' value="Nona">Nona</option>' +
                                "</select>" +
                                '<input type="text" class="form-control" value="' +
                                $(this)
                                  .text()
                                  .replace("Tuan ", "")
                                  .replace("Nyonya ", "")
                                  .replace("Nona ", "") +
                                '" id="' +
                                $(this).attr("id") +
                                '" name="' +
                                $(this).attr("id") +
                                '" form="' +
                                holder +
                                '" required>'
                            );
                          } else if ($(this).attr("id") == "TanggalSelesai") {
                            $(this).html(
                              '<input type="date" class="form-control addLensaDate" value="' +
                                $(this).text() +
                                '" id="' +
                                $(this).attr("id") +
                                '" name="' +
                                $(this).attr("id") +
                                '" form="' +
                                holder +
                                '" max=' +
                                $("#TanggalSelesai").attr("max") +
                                ">"
                            );
                          } else if (
                            $(this).attr("id") == "idLensa" ||
                            $(this).attr("id") == "idFrame" ||
                            $(this).attr("id") == "idBox"
                          ) {
                            $(this).html(
                              '<input type="text" required class="form-control addLensaDate" value="' +
                                $(this).attr("name") +
                                '" id="' +
                                ("temp" + $(this).attr("id") + holder) +
                                '" form="' +
                                holder +
                                '" list="daftar' +
                                $(this).attr("id") +
                                '">'
                            );
                          } else if ($(this).attr("id") == "Harga") {
                            $(this).html(
                              '<input type="number" readonly class="form-control addLensaDate" value="' +
                                $(this)
                                  .text()
                                  .substring(0, $(this).text().length - 2)
                                  .replace(/\D/g, "") +
                                '" id="' +
                                $(this).attr("id") +
                                '" name="' +
                                $(this).attr("id") +
                                '" form="' +
                                holder +
                                '">'
                            );
                          } else if ($(this).attr("id") == "noPembelian") {
                            $(this).html(
                              '<input type="number" readonly class="form-control addLensaDate" value="' +
                                $(this).text() +
                                '" id="' +
                                $(this).attr("id") +
                                '" name="' +
                                $(this).attr("id") +
                                '" form="' +
                                holder +
                                '">'
                            );
                          } else if ($(this).attr("id") == "UangMuka") {
                            $(this).html(
                              '<input type="number" class="form-control addLensaDate" value="' +
                                $(this)
                                  .text()
                                  .substring(0, $(this).text().length - 2)
                                  .replace(/\D/g, "") +
                                '" id="' +
                                $(this).attr("id") +
                                '" name="' +
                                $(this).attr("id") +
                                '" form="' +
                                holder +
                                '" required>'
                            );
                          } else if ($(this).attr("id") == "action") {
                          } else {
                            $(this).html(
                              '<input type="text" class="form-control" value="' +
                                $(this).text() +
                                '" id="' +
                                $(this).attr("id") +
                                '" name="' +
                                $(this).attr("id") +
                                '" form="' +
                                holder +
                                '" required>'
                            );
                          }
                        });
                      $(this).parents("tr").find(".add, .edit").toggle();
                      // $(".add-new").attr("disabled", "disabled");
                      //   $(this).parents("tr").find("form").attr("action","/api/Mahasiswa/update");
                    });
                  });
                </script>

                <table class="table table-striped table-hover tableFixHead">
                  <thead>
                    <tr>
                      <th>No</th>
                      <th>Pembeli</th>
                      <th>Pemeriksa</th>
                      <th>Lensa</th>
                      <th>Frame</th>
                      <th>Box</th>
                      <th>Selesai</th>
                      <th>Total</th>
                      <th>Uang Muka</th>
                      <th>Aksi</th>
                      <th>Aksi</th>
                    </tr>
                  </thead>
                  <tbody>
                    <div th:each="pembelian : ${DataPembelian}">
                      <tr
                        th:data-status="${pembelian.TanggalSelesai}=='' ? 'inactive' : 'active'"
                      >
                        <form
                          th:action="@{/pembelian/update}"
                          method="post"
                          th:id="${pembelian.Id}"
                        >
                          <input
                            type="hidden"
                            hidden
                            th:id="'updateLensa' + ${pembelian.Id}"
                            name="idLensa"
                          />
                          <input
                            type="hidden"
                            hidden
                            th:id="'updateFrame' + ${pembelian.Id}"
                            name="idFrame"
                          />
                          <input
                            type="hidden"
                            hidden
                            th:id="'updateBox' + ${pembelian.Id}"
                            name="idBox"
                          />
                        </form>
                        <td
                          th:text="${pembelian.Id}"
                          id="Id"
                          class="d-none"
                        ></td>
                        <td
                          th:text="${pembelian.noPembelian}"
                          id="noPembelian"
                        ></td>
                        <td
                          th:text="${pembelian.KategoriPembeli} + ' ' + ${pembelian.Pembeli}"
                          id="Pembeli"
                        ></td>
                        <td
                          th:text="${pembelian.DrPemeriksa}"
                          id="DrPemeriksa"
                        ></td>
                        <td
                          id="idLensa"
                          th:name="${pembelian.lensa.NamaLensa} + ' | '+ ${pembelian.lensa.JenisLensa} + ' | ['+ ${pembelian.lensa.UkuranKiri} + ', '+ ${pembelian.lensa.UkuranKanan} +']'"
                        >
                          <a
                            th:href="'/lensa/' + ${pembelian.lensa.NamaLensa}"
                            th:text="${pembelian.lensa.NamaLensa}"
                          ></a>
                        </td>
                        <td
                          id="idFrame"
                          th:name="${pembelian.frame.NamaFrame} + ' | '+ ${pembelian.frame.JenisFrame}"
                        >
                          <a
                            th:href="'/frame/' + ${pembelian.frame.NamaFrame}"
                            th:text="${pembelian.frame.NamaFrame}"
                          ></a>
                        </td>
                        <td
                          id="idBox"
                          th:name="${pembelian.box.NamaBox} + ' | '+ ${pembelian.box.JenisBox}"
                        >
                          <a
                            th:href="'/box/' + ${pembelian.box.NamaBox}"
                            th:text="${pembelian.box.NamaBox}"
                          ></a>
                        </td>
                        <td
                          th:text="${pembelian.TanggalSelesai}"
                          id="TanggalSelesai"
                        ></td>
                        <td
                          th:text="'Rp'+${#numbers.formatDecimal((pembelian.lensa.Harga+pembelian.frame.Harga+pembelian.box.Harga), 0, 'POINT', 2, 'COMMA')}"
                          id="Harga"
                        ></td>
                        <td
                          th:text="'Rp'+${#numbers.formatDecimal(pembelian.UangMuka, 0, 'POINT', 2, 'COMMA')}"
                          id="UangMuka"
                        ></td>
                        <td id="action">
                          <button
                            class="add DateHelper"
                            style="display: none"
                            title="Add"
                            th:id="'btnUpdate' + ${pembelian.Id}"
                          >
                            <i class="material-icons" th:form="${pembelian.Id}"
                              >&#xE03B;</i
                            >
                          </button>
                          <a title="Edit" class="btn btn-sm manage edit"
                            ><i class="fa-solid fa-pen-to-square"></i
                          ></a>
                        </td>
                        <td>
                          <a
                            title="print"
                            class="btn btn-sm manage"
                            th:href="'/pembelian/print/'+${pembelian.Id}"
                            target="_blank"
                            rel="noopener noreferrer"
                            ><i class="fa-solid fa-download"></i
                          ></a>
                        </td>
                      </tr>
                    </div>
                  </tbody>
                </table>
              </div>
            </div>
          </div>
        </div>
        <!-- /.container-fluid -->
      </div>
      <!-- End of Main Content -->

      <!-- Footer -->
      <footer class="sticky-footer bg-white">
        <div class="container my-auto">
          <div class="copyright text-center my-auto">
            <span>Copyright &copy; Your Website 2020</span>
          </div>
        </div>
      </footer>
      <!-- End of Footer -->
    </div>
    <!-- End of Content Wrapper -->
  </div>
  <!-- End of Page Wrapper -->

  <!-- Scroll to Top Button-->
  <a class="scroll-to-top rounded" href="#page-top">
    <i class="fas fa-angle-up"></i>
  </a>

  <!-- Logout Modal-->
  <div
    class="modal fade"
    id="logoutModal"
    tabindex="-1"
    role="dialog"
    aria-labelledby="exampleModalLabel"
    aria-hidden="true"
  >
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="exampleModalLabel">Ready to Leave?</h5>
          <button
            class="close"
            type="button"
            data-dismiss="modal"
            aria-label="Close"
          >
            <span aria-hidden="true">×</span>
          </button>
        </div>
        <div class="modal-body">
          Select "Logout" below if you are ready to end your current session.
        </div>
        <div class="modal-footer">
          <button class="btn btn-secondary" type="button" data-dismiss="modal">
            Cancel
          </button>
          <a class="btn btn-primary" href="login.html">Logout</a>
        </div>
      </div>
    </div>
  </div>
</body>

<div th:replace="@{Lensa/Layout/Bottom}"></div>
